plugins {
    `java-gradle-plugin`
    id("org.gradle.kotlin.kotlin-dsl")
    `maven-publish`
}

group = rootProject.group
version = rootProject.version

repositories {
    mavenCentral()
    gradlePluginPortal()
    maven {
        name = "Fabric"
        url = uri("https://maven.fabricmc.net/")
    }
    maven {
        name = "CurseGradle"
        url = uri("https://gitlab.com/api/v4/projects/32776914/packages/maven")
    }
}

publishing {
    repositories {
        if (project.hasProperty("maven")) {
            maven(project.property("maven") as String) {
                name = "dynamic"

                credentials(HttpHeaderCredentials::class) {
                    name = "Job-Token"
                    value = System.getenv()["CI_JOB_TOKEN"]
                }
                authentication {
                    create<HttpHeaderAuthentication>("header")
                }
            }
        }
        mavenLocal()
    }
}